// $Id: MTime.xs,v 1.2 2000/11/20 23:51:05 dave Exp $
// Copyright (C) 2000 Paul Martin and Dave Woodcock. All rights reserved.

#include <config.h>

#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <sys/time.h>
#include <unistd.h>

MODULE = MTime		PACKAGE = MTime

int
mtime()
  PREINIT:
    struct timeval tv;
    struct timezone tz;
  CODE:
    tz.tz_minuteswest = 0;
    tz.tz_dsttime     = 0;
    if (gettimeofday(&tv, &tz) == 0) {
      // milliseconds since 0:00 GMT
      RETVAL = 1000 * (tv.tv_sec % 86400) + (tv.tv_usec / 1000);
    } else {
      fprintf(stderr, "Call to gettimeofday failed\n");
      exit(1);
    }
  OUTPUT:
    RETVAL

void
msleep(ms)
  int ms;
  CODE:
    usleep(1000 * ms);

