# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..6\n"; }
END {print "not ok 1\n" unless $loaded;}
use SemaphoreSet;
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

my $sem = new SemaphoreSet
  ('full'  => 0,
   'empty' => 2,
   'mutex' => 1,
  )
  and print "ok 2\n";

defined(my $pid = fork)
  or die("Fork failed: $!\n");

my $count = 3;
my @producer_sleep = (1, 0, 0, 0);
my @consumer_sleep = (0, 0, 0, 1);

if ($pid) { # Parent - produce
  while (@producer_sleep) {
    sleep(shift @producer_sleep);
    $sem->down('full');
    $sem->down('mutex');
    # Producer code goes here
    $sem->up('mutex');
    $sem->up('empty');
    print "ok ", $count++, "\n";
  }

} else {    # Child - consume
  while (@consumer_sleep) {
    sleep(shift @consumer_sleep);
    $sem->down('empty');
    $sem->down('mutex');
    # Consumer code goes here
    $sem->up('mutex');
    $sem->up('full');
  }
}
