# $Id: rootSystem.xs,v 1.1 2000/01/03 08:16:38 dave Exp $
# Copyright (C) 2000 Paul Martin and Dave Woodcock. All rights reserved.

MODULE = Tilt		PACKAGE = rootSystem

rootSystem *
rootSystem::new(name)
  char* name;
  CODE:
    RETVAL = new rootSystem(name);
  OUTPUT:
    RETVAL

void
rootSystem::DESTROY()

int
rootSystem::rank()
  CODE:
    RETVAL = THIS->rank;
  OUTPUT:
    RETVAL

char*
rootSystem::type()
  PREINIT:
    char c[2];
  CODE:
    c[0] = THIS->type;
    c[1] = '\0';
    RETVAL = c;
  OUTPUT:
    RETVAL

char*
rootSystem::ident()
  CODE:
    RETVAL = THIS->ident;
  OUTPUT:
    RETVAL

int
rootSystem::prime()
  CODE:
    RETVAL = THIS->prime;
  OUTPUT:
    RETVAL

int
rootSystem::numPositiveRoots()
  CODE:
    RETVAL = THIS->numPositiveRoots;
  OUTPUT:
    RETVAL

int
rootSystem::weylSize()
  CODE:
    RETVAL = THIS->weylSize;
  OUTPUT:
    RETVAL

intmat *
rootSystem::cartanMat()
  CODE:
    char * CLASS = CLASS_intmat;
    RETVAL = new intmat(THIS->cartanMat);
  OUTPUT:
    RETVAL

intmat *
rootSystem::bilinearForm()
  CODE:
    char * CLASS = CLASS_intmat;
    RETVAL = new intmat(THIS->bilinearForm);
  OUTPUT:
    RETVAL

intmat *
rootSystem::identityMat()
  CODE:
    char * CLASS = CLASS_intmat;
    RETVAL = new intmat(THIS->identityMat);
  OUTPUT:
    RETVAL

intvec *
rootSystem::rho()
  CODE:
    char * CLASS = CLASS_intvec;
    RETVAL = new intvec(THIS->rho);
  OUTPUT:
    RETVAL

intvec *
rootSystem::origin()
  CODE:
    char * CLASS = CLASS_intvec;
    RETVAL = new intvec(THIS->origin);
  OUTPUT:
    RETVAL

floatmat *
rootSystem::onTransform()
  CODE:
    char * CLASS = CLASS_floatmat;
    RETVAL = new floatmat(THIS->onTransform);
  OUTPUT:
    RETVAL

SV *
rootSystem::s()
  CODE:
    // The array of CoxeterGenerators
    int rank = THIS->rank;
    AV* a = newAV(); // creates with refcount = 1
    affineWeyl *s = THIS->s;

    while(rank-- >= 0) {
      // copy it so we don't have destructor problems
      affineWeyl *w = new affineWeyl(*s++);

      // create new SV with no string allocation,
      // turn it into a reference to the given affineWeyl
      // element, blessed into class affineWeyl,
      // push it onto the results array
      // I believe that pushing does not increment the ref count

      SV* t = newSV(0);
      sv_setref_pv(t, "affineWeyl", (void *)w);
      av_push(a, t);
    }

    // RETVAL is returned with refcount of 1,
    // and each of its components have refcount 1 too
    RETVAL = newRV_noinc((SV*)a);
  OUTPUT:
    RETVAL

# intvec *fundamentalVertex; // vertices of fundamental alcove (scaled)
# intvec *alcoveFace;        /* lists indices of the points of the faces of the
#				   fundamental alcove */
# affineWeyl *s;             // Coxeter generators of affine Weyl group
# void reset(const char* CM);
# ostream& print(ostream&) const;
# ostream& printWeylGroup(ostream&) const;
# affineWeyl aw(const intvec& v) const;  // affine Weyl elt corresponding to
