m4_divert(-1)

// $Id: include.m4,v 1.2 2000/11/20 23:51:02 dave Exp $
// Copyright (C) 2000 Paul Martin and Dave Woodcock. All rights reserved.
// m4 macros for processing the libtilt sources.

m4_changequote([,])
m4_changequote(``,'')
m4_changecom(//)

// {{{ misc

m4_define(``m4_upcase'',``m4_translit(``$1'',``a-z'',``A-Z'')'')
m4_define(``m4_downcase'',``m4_translit(``$1'',``A-Z'',``a-z'')'')
m4_define(``m4_capitalise'',``m4_upcase(m4_substr($1,0,1))``''m4_substr($1,1)'')
m4_define(``m4_uncapitalise'',``m4_downcase(m4_substr($1,0,1))``''m4_substr($1,1)'')

// m4_ifin(x,y,z)
//    expands to z if the character x appears in the string y, else empty
m4_define(``m4_ifin'',``m4_ifelse($2,m4_patsubst($2,$1,),$4,$3)m4_dnl'')

// }}}
// {{{ HASHLINE

// The ``m4_dnl'' eats up anything remaining on the line which invoked
// HASHLINE. This is to allow the source file to have a final
// semicolon, thus satisfying c++-mode, but having it chomped from
// the final file.

m4_define(``HASHLINE'',``#line m4___line__ "m4___file__"
m4_dnl'')

// }}}
// {{{ WARNING

// Note that it is WARNING which reenables the output.
// Without a WARNING nothing at all comes out until an
// ``m4_divert'' is supplied elsewhere, for example in HEND.

m4_define(``WARNING'',``m4_divert//
// WARNING  WARNING  WARNING
//   This file has been automatically generated by m4.
//   To make permanent changes you must edit
//   the corresponding m4 source file.
// WARNING  WARNING  WARNING
//
m4_undefine(``WARNING'')m4_dnl'')

// }}}
// {{{ H_BEGIN

m4_define(``H_BEGIN'',``m4_ifdef(``HFILE'',``#ifndef __h_$1__
#define __h_$1__
#pragma interface "$1.h"
#include <config.h>
HASHLINE'',``m4_divert(-1)'')'')

// }}}
// {{{ H_END

m4_define(``H_END'',``m4_ifdef(``HFILE'',``#endif // __h_$1__'',``m4_divert
'')
m4_dnl'')

// }}}
// {{{ C_BEGIN

m4_define(``C_BEGIN'',``m4_ifdef(``CFILE'',``#pragma implementation "$1.h"
#include "$1.h"
HASHLINE'',``m4_divert(-1)'')'')

// }}}
// {{{ C_END

m4_define(``C_END'',``m4_ifdef(``CFILE'',``'',``m4_divert
'')
m4_dnl'')

// }}}
// {{{ D_BEGIN

m4_define(``D_BEGIN'',``m4_ifdef(``DFILE'',``#include "$1.h"
HASHLINE'',``m4_divert(-1)'')'')

// }}}
// {{{ D_END

m4_define(``D_END'',``m4_ifdef(``DFILE'',``'',``m4_divert
'')
m4_dnl'')

// }}}

// {{{ Local Variables

// Local Variables:
// mode: fundamental
// fold-top-mark: "// {{{"
// fold-bottom-mark: "// }}}"
// folded-file: t
// tab-width: 4
// End:

// }}}


