WARNING;
// Copyright (C) 2000 Paul Martin and Dave Woodcock. All rights reserved.
// $Id: floatmat.m4,v 1.5 2000/11/20 23:51:24 dave Exp $
H_BEGIN(floatmat);

#include "urmat.h"
#include "intmat.h"
#include "floatvec.h"
#include <math.h>

typedef urmat<float> floatmat;
floatmat Floatmat(const intmat&);

inline float sqrt(float a) {
  return float(sqrt(double(a)));
}

H_END(floatmat);
C_BEGIN(floatmat);

// {{{ explicit template instantiations

template class urarray<float>;
template class urmat<float>;
template void GramSchmidt(urmat<float>&, const urmat<float>&);
template urmat<float> inv(const urmat<float>&);
// template urvec<float> operator*(const urvec<float>&, urmat<float>&);
template ostream& operator<<(ostream&, const urmat<float>&);

// }}}

// const float floatmat::zero = 0;
// const float floatmat::one = 1;

// {{{ Floatmat()

floatmat Floatmat(const intmat& m) {
  floatmat res(m.height(), m.width());
  for (unsigned int i = 0; i < m.height(); ++i)
    for (unsigned int j = 0; j < m.width(); ++j)
      res(i,j) = m(i,j);
  return res;
}

// }}}

C_END(floatmat);

// {{{ Local Variables

// Local Variables:
// mode: c++
// folded-file: t
// End:

// }}}
