WARNING;
// Copyright (C) 2000 Paul Martin and Dave Woodcock. All rights reserved.
// $Id: hcf.m4,v 1.4 2000/11/13 06:16:44 dave Exp $
H_BEGIN(hcf);

#include "intlist.h"

int hcf(int, int);
int hcf(const intlist &);
int lcm(int, int);
int lcm(const intlist &);

H_END(hcf);
C_BEGIN(hcf);

// {{{ hcf()

// {{{ (int, int)

int hcf(int a, int b) {
  if (a < 0)
    a = -a;
  if (b < 0)
    b = -b;
  if (a < b) {
    int c = a;
    a = b;
    b = c;
  }
  int remainder;
  while (b) {
    remainder = a % b;
    a = b;
    b = remainder;
  }
  return a;
}

// }}}
// {{{ (const intlist&)

int hcf(const intlist& v) {
  int len = v.len();
  if (len) {
    int result = v[0], i = 0;
    while (--len)
      result = hcf(result, v[++i]);
    return result;
  } else {
    return 0;
  }
}

// }}}

// }}}
// {{{ lcm()

// {{{ (int, int)

int lcm(int a, int b) {
  if ((a == 0) || (b == 0))
    return 0;
  if (a < 0)
    a = -a;
  if (b < 0)
    b = -b;
  if (a < b) {
    int c = a;
    a = b;
    b = c;
  }
  int A = a, B = b, remainder;
  while (b) {
    remainder = a % b;
    a = b;
    b = remainder;
  }
  return A / a * B;
}

// }}}
// {{{ (const intlist&)

int lcm(const intlist & v) {
  int len = v.len();
  if (len) {
    int result = v[0], i = 0;
    while (--len)
      result = lcm(result, v[++i]);
    return result;
  } else {
    return 1;
  }
}

// }}}

// }}}

C_END(hcf);

// {{{ Local Variables

// Local Variables:
// mode: c++
// folded-file: t
// End:

// }}}

