WARNING;
// Copyright (C) 2000 Paul Martin and Dave Woodcock. All rights reserved.
// $Id: newline.m4,v 1.2 2000/11/13 06:16:59 dave Exp $
H_BEGIN(newline);

// Object which when printed outputs a newline followed by
// a variable amount of indentation.

// The amount of indentation is in/de-creased
// using prefix ++/--.

#include <iostream.h>

// {{{ class newline

class newline {
  unsigned int step;
  unsigned int indent;
public:
  newline(unsigned int s, unsigned int i = 0) : step(s), indent(i) {};
  newline& operator ++() {indent += step; return *this;}
  newline& operator --() {indent -= step; return *this;}
  ostream& print(ostream&) const;
};


inline ostream& operator << (ostream&s, const newline& n) {
  return n.print(s);
}

// }}}

H_END(newline);
C_BEGIN(newline);

// {{{ newline members

ostream& newline::print(ostream& s) const {
  s << "\n";
  for (int i = indent; i--;) s << " ";
  return s;
}

// }}}

C_END(newline);

// {{{ Local Variables

// Local Variables:
// mode: c++
// folded-file: t
// End:

// }}}
